﻿Type=Service
Version=2.71
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#StartCommandReturnValue: android.app.Service.START_STICKY
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Private Timer As Timer
	Dim LastTitle(3) As String
	Dim LastValue(3) As String
	
End Sub

Sub Service_Create
	
End Sub

Sub Service_Start (StartingIntent As Intent)
	Timer.Initialize("Timer", DateTime.TicksPerSecond)
End Sub

Sub Service_Destroy

End Sub

Sub Timer_Tick

	If IsScreenOn AND Not(IsPaused(Main)) Then 
		CallSub(Main,"Action")
	Else
		' take over the increment or decrement
		' only for WheelType TimeUp or TimeDown
		For i = 0 To 2
			If LastValue(i) <> "" Then
				If (LastValue(i).SubString2(0,1) = 1) AND (LastValue(i).SubString2(1,2) = 1) Then
					If LastValue(i).SubString2(2,8) <> "995959" Then
						LastValue(i) =  "11" & SixDigitScroll(LastValue(i).SubString2(2,8),True)
					End If
				Else If (LastValue(i).SubString2(0,1) = 2) AND (LastValue(i).SubString2(1,2) = 1) Then
					If LastValue(i).SubString2(1,8) <> "000000" Then
						LastValue(i) =  "21" & SixDigitScroll(LastValue(i).SubString2(2,8), False)	
					End If
				End If	
			End If
		Next 
	End If
	
End Sub

Sub Timer_Start

'	If Timer.IsInitialized Then
		Timer.Enabled = True
'	End If
	
End Sub

Sub Timer_Stop
		
	Timer.Enabled = False
	
End Sub

Sub IsScreenOn As Boolean

    Dim r As Reflector
    r.Target = r.GetContext
    r.Target = r.RunMethod2("getSystemService", "power", "java.lang.String")
    Return r.RunMethod("isScreenOn")
	
End Sub

Public Sub SixDigitScroll(SixDigit As String, ScrollUp As Boolean) As String

	' because it can be more than 24 hours,
	' be carefull if using datetime manipulation.

	Dim intSixDigit As Int = 1000000 + SixDigit
	If ScrollUp Then
		intSixDigit = intSixDigit + 1
		SixDigit = intSixDigit
		If SixDigit.substring2(5,7) = "60" Then
			intSixDigit = SixDigit.SubString2(0,5) + 1
			SixDigit = intSixDigit & "00"
		End If
		If SixDigit.substring2(3,5) = "60" Then
			intSixDigit = SixDigit.SubString2(0,3) + 1
			SixDigit = intSixDigit & "0000"
		End If
	Else
		intSixDigit = intSixDigit - 1
		SixDigit = intSixDigit
		If SixDigit.substring2(5,7) = "99" Then
			intSixDigit = SixDigit.SubString2(0,5) 
			SixDigit = intSixDigit & "59"
		End If
		If SixDigit.substring2(3,5) = "99" Then
			intSixDigit = SixDigit.SubString2(0,3)
			SixDigit = intSixDigit & "5959"
		End If
	End If
	Log("Sixdigit: " & SixDigit)
	
	intSixDigit = SixDigit.substring(1)
	If ScrollUp Then
		If intSixDigit = 995959 Then
			StartServiceAt(AlarmService,DateTime.Now,True)
		End If
	Else
		If intSixDigit = 0 Then
			StartServiceAt(AlarmService,DateTime.Now,True)
		End If
	End If
		
	Return SixDigit.substring(1)
	
End Sub

